Index: uspace/lib/c/generic/net/socket_client.c
===================================================================
--- uspace/lib/c/generic/net/socket_client.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/generic/net/socket_client.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -79,4 +79,9 @@
 typedef struct socket socket_t;
 
+/** Type definition of the socket specific data pointer.
+ * @see socket
+ */
+typedef socket_t *socket_ref;
+
 /** Socket specific data.
  *
@@ -157,5 +162,5 @@
 
 	/** Active sockets. */
-	sockets_t *sockets;
+	sockets_ref sockets;
 
 	/** Safety lock.
@@ -178,11 +183,11 @@
 /** Returns the active sockets.
  *
- *  @return		The active sockets.
- */
-static sockets_t *socket_get_sockets(void)
+ *  @returns		The active sockets.
+ */
+static sockets_ref socket_get_sockets(void)
 {
 	if (!socket_globals.sockets) {
 		socket_globals.sockets =
-		    (sockets_t *) malloc(sizeof(sockets_t));
+		    (sockets_ref) malloc(sizeof(sockets_t));
 		if (!socket_globals.sockets)
 			return NULL;
@@ -208,5 +213,5 @@
 	ipc_callid_t callid;
 	ipc_call_t call;
-	socket_t *socket;
+	socket_ref socket;
 	int rc;
 
@@ -286,6 +291,6 @@
  * Connects to the TCP module if necessary.
  *
- * @return		The TCP module phone.
- * @return		Other error codes as defined for the
+ * @returns		The TCP module phone.
+ * @returns		Other error codes as defined for the
  *			bind_service_timeout() function.
  */
@@ -305,6 +310,6 @@
  * Connects to the UDP module if necessary.
  *
- * @return		The UDP module phone.
- * @return		Other error codes as defined for the
+ * @returns		The UDP module phone.
+ * @returns		Other error codes as defined for the
  *			bind_service_timeout() function.
  */
@@ -322,10 +327,10 @@
 /** Tries to find a new free socket identifier.
  *
- * @return		The new socket identifier.
- * @return		ELIMIT if there is no socket identifier available.
+ * @returns		The new socket identifier.
+ * @returns		ELIMIT if there is no socket identifier available.
  */
 static int socket_generate_new_id(void)
 {
-	sockets_t *sockets;
+	sockets_ref sockets;
 	int socket_id = 0;
 	int count;
@@ -367,5 +372,5 @@
  */
 static void
-socket_initialize(socket_t *socket, int socket_id, int phone,
+socket_initialize(socket_ref socket, int socket_id, int phone,
     services_t service)
 {
@@ -387,18 +392,18 @@
  * @param[in] type	Socket type.
  * @param[in] protocol	Socket protocol.
- * @return		The socket identifier on success.
- * @return		EPFNOTSUPPORT if the protocol family is not supported.
- * @return		ESOCKNOTSUPPORT if the socket type is not supported.
- * @return		EPROTONOSUPPORT if the protocol is not supported.
- * @return		ENOMEM if there is not enough memory left.
- * @return		ELIMIT if there was not a free socket identifier found
+ * @returns		The socket identifier on success.
+ * @returns		EPFNOTSUPPORT if the protocol family is not supported.
+ * @returns		ESOCKNOTSUPPORT if the socket type is not supported.
+ * @returns		EPROTONOSUPPORT if the protocol is not supported.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		ELIMIT if there was not a free socket identifier found
  *			this time.
- * @return		Other error codes as defined for the NET_SOCKET message.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the NET_SOCKET message.
+ * @returns		Other error codes as defined for the
  *			bind_service_timeout() function.
  */
 int socket(int domain, int type, int protocol)
 {
-	socket_t *socket;
+	socket_ref socket;
 	int phone;
 	int socket_id;
@@ -458,5 +463,5 @@
 
 	// create a new socket structure
-	socket = (socket_t *) malloc(sizeof(socket_t));
+	socket = (socket_ref) malloc(sizeof(socket_t));
 	if (!socket)
 		return ENOMEM;
@@ -509,9 +514,9 @@
  * @param[in] data	The data to be sent.
  * @param[in] datalength The data length.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data parameter is NULL.
- * @return		NO_DATA if the datalength parameter is zero (0).
- * @return		Other error codes as defined for the spcific message.
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data parameter is NULL.
+ * @returns		NO_DATA if the datalength parameter is zero (0).
+ * @returns		Other error codes as defined for the spcific message.
  */
 static int
@@ -519,5 +524,5 @@
     const void *data, size_t datalength)
 {
-	socket_t *socket;
+	socket_ref socket;
 	aid_t message_id;
 	ipcarg_t result;
@@ -554,9 +559,9 @@
  * @param[in] my_addr	The port address.
  * @param[in] addrlen	The address length.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the my_addr parameter is NULL.
- * @return		NO_DATA if the addlen parameter is zero.
- * @return		Other error codes as defined for the NET_SOCKET_BIND
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the my_addr parameter is NULL.
+ * @returns		NO_DATA if the addlen parameter is zero.
+ * @returns		Other error codes as defined for the NET_SOCKET_BIND
  *			message.
  */
@@ -575,13 +580,13 @@
  * @param[in] socket_id	Socket identifier.
  * @param[in] backlog	The maximum number of waiting sockets to be accepted.
- * @return		EOK on success.
- * @return		EINVAL if the backlog parameter is not positive (<=0).
- * @return		ENOTSOCK if the socket is not found.
- * @return		Other error codes as defined for the NET_SOCKET_LISTEN
+ * @returns		EOK on success.
+ * @returns		EINVAL if the backlog parameter is not positive (<=0).
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		Other error codes as defined for the NET_SOCKET_LISTEN
  *			message.
  */
 int listen(int socket_id, int backlog)
 {
-	socket_t *socket;
+	socket_ref socket;
 	int result;
 
@@ -613,15 +618,15 @@
  * @param[out] cliaddr	The remote client address.
  * @param[in] addrlen	The address length.
- * @return		EOK on success.
- * @return		EBADMEM if the cliaddr or addrlen parameter is NULL.
- * @return		EINVAL if the backlog parameter is not positive (<=0).
- * @return		ENOTSOCK if the socket is not found.
- * @return		Other error codes as defined for the NET_SOCKET_ACCEPT
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the cliaddr or addrlen parameter is NULL.
+ * @returns		EINVAL if the backlog parameter is not positive (<=0).
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		Other error codes as defined for the NET_SOCKET_ACCEPT
  *			message.
  */
 int accept(int socket_id, struct sockaddr * cliaddr, socklen_t * addrlen)
 {
-	socket_t *socket;
-	socket_t *new_socket;
+	socket_ref socket;
+	socket_ref new_socket;
 	aid_t message_id;
 	ipcarg_t ipc_result;
@@ -656,5 +661,5 @@
 
 	// create a new scoket
-	new_socket = (socket_t *) malloc(sizeof(socket_t));
+	new_socket = (socket_ref) malloc(sizeof(socket_t));
 	if (!new_socket) {
 		fibril_mutex_unlock(&socket->accept_lock);
@@ -716,9 +721,9 @@
  * @param[in] serv_addr	The remote server address.
  * @param[in] addrlen	The address length.
- * @return		EOK on success.
- * @return		EBADMEM if the serv_addr parameter is NULL.
- * @return		NO_DATA if the addlen parameter is zero.
- * @return		ENOTSOCK if the socket is not found.
- * @return		Other error codes as defined for the NET_SOCKET_CONNECT
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the serv_addr parameter is NULL.
+ * @returns		NO_DATA if the addlen parameter is zero.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		Other error codes as defined for the NET_SOCKET_CONNECT
  *			message.
  */
@@ -740,5 +745,5 @@
  * @param[in] socket	The socket to be destroyed.
  */
-static void socket_destroy(socket_t *socket)
+static void socket_destroy(socket_ref socket)
 {
 	int accepted_id;
@@ -756,14 +761,14 @@
  *
  * @param[in] socket_id	Socket identifier.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EINPROGRESS if there is another blocking function in
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EINPROGRESS if there is another blocking function in
  *			progress.
- * @return		Other error codes as defined for the NET_SOCKET_CLOSE
+ * @returns		Other error codes as defined for the NET_SOCKET_CLOSE
  *			message.
  */
 int closesocket(int socket_id)
 {
-	socket_t *socket;
+	socket_ref socket;
 	int rc;
 
@@ -806,10 +811,10 @@
  *			sockets.
  * @param[in] addrlen	The address length. Used only if toaddr is not NULL.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data or toaddr parameter is NULL.
- * @return		NO_DATA if the datalength or the addrlen parameter is
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data or toaddr parameter is NULL.
+ * @returns		NO_DATA if the datalength or the addrlen parameter is
  *			zero (0).
- * @return		Other error codes as defined for the NET_SOCKET_SENDTO
+ * @returns		Other error codes as defined for the NET_SOCKET_SENDTO
  *			message.
  */
@@ -819,5 +824,5 @@
     socklen_t addrlen)
 {
-	socket_t *socket;
+	socket_ref socket;
 	aid_t message_id;
 	ipcarg_t result;
@@ -908,9 +913,9 @@
  * @param[in] datalength The data length.
  * @param[in] flags	Various send flags.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data parameter is NULL.
- * @return		NO_DATA if the datalength parameter is zero.
- * @return		Other error codes as defined for the NET_SOCKET_SEND
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data parameter is NULL.
+ * @returns		NO_DATA if the datalength parameter is zero.
+ * @returns		Other error codes as defined for the NET_SOCKET_SEND
  *			message.
  */
@@ -932,10 +937,10 @@
  * @param[in] toaddr	The destination address.
  * @param[in] addrlen	The address length.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data or toaddr parameter is NULL.
- * @return		NO_DATA if the datalength or the addrlen parameter is
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data or toaddr parameter is NULL.
+ * @returns		NO_DATA if the datalength or the addrlen parameter is
  *			zero.
- * @return		Other error codes as defined for the NET_SOCKET_SENDTO
+ * @returns		Other error codes as defined for the NET_SOCKET_SENDTO
  *			message.
  */
@@ -966,9 +971,9 @@
  *			read. The actual address length is set. Used only if
  *			fromaddr is not NULL.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data parameter is NULL.
- * @return		NO_DATA if the datalength or addrlen parameter is zero.
- * @return		Other error codes as defined for the spcific message.
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data parameter is NULL.
+ * @returns		NO_DATA if the datalength or addrlen parameter is zero.
+ * @returns		Other error codes as defined for the spcific message.
  */
 static int
@@ -976,5 +981,5 @@
     int flags, struct sockaddr *fromaddr, socklen_t *addrlen)
 {
-	socket_t *socket;
+	socket_ref socket;
 	aid_t message_id;
 	ipcarg_t ipc_result;
@@ -1095,9 +1100,9 @@
  * @param[in] datalength The data length.
  * @param[in] flags	Various receive flags.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data parameter is NULL.
- * @return		NO_DATA if the datalength parameter is zero.
- * @return		Other error codes as defined for the NET_SOCKET_RECV
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data parameter is NULL.
+ * @returns		NO_DATA if the datalength parameter is zero.
+ * @returns		Other error codes as defined for the NET_SOCKET_RECV
  *			message.
  */
@@ -1118,9 +1123,9 @@
  * @param[in,out] addrlen The address length. The maximum address length is
  *			read. The actual address length is set.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the data or fromaddr parameter is NULL.
- * @return		NO_DATA if the datalength or addrlen parameter is zero.
- * @return		Other error codes as defined for the NET_SOCKET_RECVFROM
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the data or fromaddr parameter is NULL.
+ * @returns		NO_DATA if the datalength or addrlen parameter is zero.
+ * @returns		Other error codes as defined for the NET_SOCKET_RECVFROM
  *			message.
  */
@@ -1148,9 +1153,9 @@
  * @param[in,out] optlen The value buffer length. The maximum length is read.
  *			The actual length is set.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the value or optlen parameter is NULL.
- * @return		NO_DATA if the optlen parameter is zero.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the value or optlen parameter is NULL.
+ * @returns		NO_DATA if the optlen parameter is zero.
+ * @returns		Other error codes as defined for the
  *			NET_SOCKET_GETSOCKOPT message.
  */
@@ -1158,5 +1163,5 @@
 getsockopt(int socket_id, int level, int optname, void *value, size_t *optlen)
 {
-	socket_t *socket;
+	socket_ref socket;
 	aid_t message_id;
 	ipcarg_t result;
@@ -1201,9 +1206,9 @@
  * @param[in] value	The value to be set.
  * @param[in] optlen	The value length.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
- * @return		EBADMEM if the value parameter is NULL.
- * @return		NO_DATA if the optlen parameter is zero.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
+ * @returns		EBADMEM if the value parameter is NULL.
+ * @returns		NO_DATA if the optlen parameter is zero.
+ * @returns		Other error codes as defined for the
  *			NET_SOCKET_SETSOCKOPT message.
  */
Index: uspace/lib/c/include/adt/char_map.h
===================================================================
--- uspace/lib/c/include/adt/char_map.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/adt/char_map.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -48,4 +48,9 @@
 typedef struct char_map	char_map_t;
 
+/** Type definition of the character string to integer map pointer.
+ *  @see char_map
+ */
+typedef char_map_t *char_map_ref;
+
 /** Character string to integer map item.
  *
@@ -64,15 +69,15 @@
 	int next;
 	/** Next character array. */
-	char_map_t **items;
+	char_map_ref *items;
 	/** Consistency check magic value. */
 	int magic;
 };
 
-extern int char_map_initialize(char_map_t *);
-extern void char_map_destroy(char_map_t *);
-extern int char_map_exclude(char_map_t *, const char *, size_t);
-extern int char_map_add(char_map_t *, const char *, size_t, const int);
-extern int char_map_find(const char_map_t *, const char *, size_t);
-extern int char_map_update(char_map_t *, const char *, size_t, const int);
+extern int char_map_initialize(char_map_ref);
+extern void char_map_destroy(char_map_ref);
+extern int char_map_exclude(char_map_ref, const char *, size_t);
+extern int char_map_add(char_map_ref, const char *, size_t, const int);
+extern int char_map_find(const char_map_ref, const char *, size_t);
+extern int char_map_update(char_map_ref, const char *, size_t, const int);
 
 #endif
Index: uspace/lib/c/include/adt/dynamic_fifo.h
===================================================================
--- uspace/lib/c/include/adt/dynamic_fifo.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/adt/dynamic_fifo.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -44,4 +44,9 @@
 typedef struct dyn_fifo	dyn_fifo_t;
 
+/** Type definition of the dynamic fifo queue pointer.
+ *  @see dyn_fifo
+ */
+typedef dyn_fifo_t *dyn_fifo_ref;
+
 /** Dynamic first in first out positive integer queue.
  * Possitive integer values only.
@@ -61,9 +66,9 @@
 };
 
-extern int dyn_fifo_initialize(dyn_fifo_t *, int);
-extern int dyn_fifo_destroy(dyn_fifo_t *);
-extern int dyn_fifo_push(dyn_fifo_t *, int, int);
-extern int dyn_fifo_pop(dyn_fifo_t *);
-extern int dyn_fifo_value(dyn_fifo_t *);
+extern int dyn_fifo_initialize(dyn_fifo_ref, int);
+extern int dyn_fifo_destroy(dyn_fifo_ref);
+extern int dyn_fifo_push(dyn_fifo_ref, int, int);
+extern int dyn_fifo_pop(dyn_fifo_ref);
+extern int dyn_fifo_value(dyn_fifo_ref);
 
 #endif
Index: uspace/lib/c/include/adt/generic_char_map.h
===================================================================
--- uspace/lib/c/include/adt/generic_char_map.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/adt/generic_char_map.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -55,4 +55,5 @@
 	\
 	typedef	struct name name##_t; \
+	typedef	name##_t *name##_ref; \
 	\
 	struct	name { \
@@ -62,11 +63,11 @@
 	}; \
 	\
-	int name##_add(name##_t *, const char *, const size_t, type *); \
-	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *); \
-	void name##_exclude(name##_t *, const char *, const size_t); \
-	type *name##_find(name##_t *, const char *, const size_t); \
-	int name##_initialize(name##_t *); \
-	int name##_is_valid(name##_t *);
+	int name##_add(name##_ref, const char *, const size_t, type *); \
+	int name##_count(name##_ref); \
+	void name##_destroy(name##_ref); \
+	void name##_exclude(name##_ref, const char *, const size_t); \
+	type *name##_find(name##_ref, const char *, const size_t); \
+	int name##_initialize(name##_ref); \
+	int name##_is_valid(name##_ref);
 
 /** Character string to generic type map implementation.
@@ -80,5 +81,5 @@
 	GENERIC_FIELD_IMPLEMENT(name##_items, type) \
 	\
-	int name##_add(name##_t *map, const char *name, const size_t length, \
+	int name##_add(name##_ref map, const char *name, const size_t length, \
 	     type *value) \
 	{ \
@@ -98,5 +99,5 @@
 	} \
 	\
-	int name##_count(name##_t *map) \
+	int name##_count(name##_ref map) \
 	{ \
 		return name##_is_valid(map) ? \
@@ -104,5 +105,5 @@
 	} \
 	\
-	void name##_destroy(name##_t *map) \
+	void name##_destroy(name##_ref map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -112,5 +113,5 @@
 	} \
 	\
-	void name##_exclude(name##_t *map, const char *name, \
+	void name##_exclude(name##_ref map, const char *name, \
 	    const size_t length) \
 	{ \
@@ -124,5 +125,5 @@
 	} \
 	\
-	type *name##_find(name##_t *map, const char *name, \
+	type *name##_find(name##_ref map, const char *name, \
 	    const size_t length) \
 	{ \
@@ -137,5 +138,5 @@
 	} \
 	\
-	int name##_initialize(name##_t *map) \
+	int name##_initialize(name##_ref map) \
 	{ \
 		int rc; \
@@ -154,5 +155,5 @@
 	} \
 	\
-	int name##_is_valid(name##_t *map) \
+	int name##_is_valid(name##_ref map) \
 	{ \
 		return map && (map->magic == GENERIC_CHAR_MAP_MAGIC_VALUE); \
Index: uspace/lib/c/include/adt/generic_field.h
===================================================================
--- uspace/lib/c/include/adt/generic_field.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/adt/generic_field.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -53,4 +53,5 @@
 #define GENERIC_FIELD_DECLARE(name, type) \
 	typedef	struct name name##_t; \
+	typedef	name##_t *name##_ref; \
 	\
 	struct	name { \
@@ -61,12 +62,12 @@
 	}; \
 	\
-	int name##_add(name##_t *, type *); \
-	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *); \
-	void name##_exclude_index(name##_t *, int); \
-	type **name##_get_field(name##_t *); \
-	type *name##_get_index(name##_t *, int); \
-	int name##_initialize(name##_t *); \
-	int name##_is_valid(name##_t *);
+	int name##_add(name##_ref, type *); \
+	int name##_count(name##_ref); \
+	void name##_destroy(name##_ref); \
+	void name##_exclude_index(name##_ref, int); \
+	type **name##_get_field(name##_ref); \
+	type *name##_get_index(name##_ref, int); \
+	int name##_initialize(name##_ref); \
+	int name##_is_valid(name##_ref);
 
 /** Generic type field implementation.
@@ -78,5 +79,5 @@
  */
 #define GENERIC_FIELD_IMPLEMENT(name, type) \
-	int name##_add(name##_t *field, type *value) \
+	int name##_add(name##_ref field, type *value) \
 	{ \
 		if (name##_is_valid(field)) { \
@@ -98,10 +99,10 @@
 	} \
 	\
-	int name##_count(name##_t *field) \
+	int name##_count(name##_ref field) \
 	{ \
 		return name##_is_valid(field) ? field->next : -1; \
 	} \
 	\
-	void name##_destroy(name##_t *field) \
+	void name##_destroy(name##_ref field) \
 	{ \
 		if (name##_is_valid(field)) { \
@@ -116,5 +117,5 @@
 	} \
 	 \
-	void name##_exclude_index(name##_t *field, int index) \
+	void name##_exclude_index(name##_ref field, int index) \
 	{ \
 		if (name##_is_valid(field) && (index >= 0) && \
@@ -125,5 +126,5 @@
 	} \
 	 \
-	type *name##_get_index(name##_t *field, int index) \
+	type *name##_get_index(name##_ref field, int index) \
 	{ \
 		if (name##_is_valid(field) && (index >= 0) && \
@@ -133,10 +134,10 @@
 	} \
 	\
-	type **name##_get_field(name##_t *field) \
+	type **name##_get_field(name##_ref field) \
 	{ \
 		return name##_is_valid(field) ? field->items : NULL; \
 	} \
 	\
-	int name##_initialize(name##_t *field) \
+	int name##_initialize(name##_ref field) \
 	{ \
 		if (!field) \
@@ -152,5 +153,5 @@
 	} \
 	\
-	int name##_is_valid(name##_t *field) \
+	int name##_is_valid(name##_ref field) \
 	{ \
 		return field && (field->magic == GENERIC_FIELD_MAGIC_VALUE); \
Index: uspace/lib/c/include/adt/int_map.h
===================================================================
--- uspace/lib/c/include/adt/int_map.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/adt/int_map.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -56,5 +56,7 @@
 #define INT_MAP_DECLARE(name, type) \
 	typedef	struct name name##_t; \
+	typedef	name##_t *name##_ref; \
 	typedef	struct name##_item name##_item_t; \
+	typedef	name##_item_t *name##_item_ref; \
 	\
 	struct	name##_item { \
@@ -67,21 +69,21 @@
 		int size; \
 		int next; \
-		name##_item_t *items; \
+		name##_item_ref items; \
 		int magic; \
 	}; \
 	\
-	int name##_add(name##_t *, int, type *); \
-	void name##_clear(name##_t *); \
-	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *); \
-	void name##_exclude(name##_t *, int); \
-	void name##_exclude_index(name##_t *, int); \
-	type *name##_find(name##_t *, int); \
-	int name##_update(name##_t *, int, int); \
-	type *name##_get_index(name##_t *, int); \
-	int name##_initialize(name##_t *); \
-	int name##_is_valid(name##_t *); \
-	void name##_item_destroy(name##_item_t *); \
-	int name##_item_is_valid(name##_item_t *);
+	int name##_add(name##_ref, int, type *); \
+	void name##_clear(name##_ref); \
+	int name##_count(name##_ref); \
+	void name##_destroy(name##_ref); \
+	void name##_exclude(name##_ref, int); \
+	void name##_exclude_index(name##_ref, int); \
+	type *name##_find(name##_ref, int); \
+	int name##_update(name##_ref, int, int); \
+	type *name##_get_index(name##_ref, int); \
+	int name##_initialize(name##_ref); \
+	int name##_is_valid(name##_ref); \
+	void name##_item_destroy(name##_item_ref); \
+	int name##_item_is_valid(name##_item_ref);
 
 /** Integer to generic type map implementation.
@@ -93,10 +95,10 @@
  */
 #define INT_MAP_IMPLEMENT(name, type) \
-	int name##_add(name##_t *map, int key, type *value) \
+	int name##_add(name##_ref map, int key, type *value) \
 	{ \
 		if (name##_is_valid(map)) { \
 			if (map->next == (map->size - 1)) { \
-				name##_item_t *tmp; \
-				tmp = (name##_item_t *) realloc(map->items, \
+				name##_item_ref tmp; \
+				tmp = (name##_item_ref) realloc(map->items, \
 				    sizeof(name##_item_t) * 2 * map->size); \
 				if (!tmp) \
@@ -115,5 +117,5 @@
 	} \
 	\
-	void name##_clear(name##_t *map) \
+	void name##_clear(name##_ref map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -130,10 +132,10 @@
 	} \
 	\
-	int name##_count(name##_t *map) \
+	int name##_count(name##_ref map) \
 	{ \
 		return name##_is_valid(map) ? map->next : -1; \
 	} \
 	\
-	void name##_destroy(name##_t *map) \
+	void name##_destroy(name##_ref map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -150,5 +152,5 @@
 	} \
 	\
-	void name##_exclude(name##_t *map, int key) \
+	void name##_exclude(name##_ref map, int key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -164,5 +166,5 @@
 	} \
 	\
-	void name##_exclude_index(name##_t *map, int index) \
+	void name##_exclude_index(name##_ref map, int index) \
 	{ \
 		if (name##_is_valid(map) && (index >= 0) && \
@@ -173,5 +175,5 @@
 	} \
 	\
-	type *name##_find(name##_t *map, int key) \
+	type *name##_find(name##_ref map, int key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -187,5 +189,5 @@
 	} \
 	\
-	int name##_update(name##_t *map, int key, int new_key) \
+	int name##_update(name##_ref map, int key, int new_key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -206,5 +208,5 @@
 	} \
 	\
-	type *name##_get_index(name##_t *map, int index) \
+	type *name##_get_index(name##_ref map, int index) \
 	{ \
 		if (name##_is_valid(map) && (index >= 0) && \
@@ -216,5 +218,5 @@
 	} \
 	\
-	int name##_initialize(name##_t *map) \
+	int name##_initialize(name##_ref map) \
 	{ \
 		if (!map) \
@@ -222,5 +224,5 @@
 		map->size = 2; \
 		map->next = 0; \
-		map->items = (name##_item_t *) malloc(sizeof(name##_item_t) * \
+		map->items = (name##_item_ref) malloc(sizeof(name##_item_t) * \
 		    map->size); \
 		if (!map->items) \
@@ -231,10 +233,10 @@
 	} \
 	\
-	int name##_is_valid(name##_t *map) \
+	int name##_is_valid(name##_ref map) \
 	{ \
 		return map && (map->magic == INT_MAP_MAGIC_VALUE); \
 	} \
 	\
-	void name##_item_destroy(name##_item_t *item) \
+	void name##_item_destroy(name##_item_ref item) \
 	{ \
 		if (name##_item_is_valid(item)) { \
@@ -247,5 +249,5 @@
 	} \
 	\
-	int name##_item_is_valid(name##_item_t *item) \
+	int name##_item_is_valid(name##_item_ref item) \
 	{ \
 		return item && (item->magic == INT_MAP_ITEM_MAGIC_VALUE); \
Index: uspace/lib/c/include/adt/measured_strings.h
===================================================================
--- uspace/lib/c/include/adt/measured_strings.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/adt/measured_strings.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -47,4 +47,9 @@
 typedef struct measured_string measured_string_t;
 
+/** Type definition of the character string with measured length pointer.
+ * @see measured_string
+ */
+typedef measured_string_t *measured_string_ref;
+
 /** Character string with measured length.
  *
@@ -59,10 +64,10 @@
 };
 
-extern measured_string_t *measured_string_create_bulk(const char *, size_t);
-extern measured_string_t *measured_string_copy(measured_string_t *);
-extern int measured_strings_receive(measured_string_t **, char **, size_t);
-extern int measured_strings_reply(const measured_string_t *, size_t);
-extern int measured_strings_return(int, measured_string_t **, char **, size_t);
-extern int measured_strings_send(int, const measured_string_t *, size_t);
+extern measured_string_ref measured_string_create_bulk(const char *, size_t);
+extern measured_string_ref measured_string_copy(measured_string_ref);
+extern int measured_strings_receive(measured_string_ref *, char **, size_t);
+extern int measured_strings_reply(const measured_string_ref, size_t);
+extern int measured_strings_return(int, measured_string_ref *, char **, size_t);
+extern int measured_strings_send(int, const measured_string_ref, size_t);
 
 #endif
Index: uspace/lib/c/include/net/device.h
===================================================================
--- uspace/lib/c/include/net/device.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/net/device.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -59,4 +59,9 @@
  */
 typedef struct device_stats device_stats_t;
+
+/** Type definition of the device usage statistics pointer.
+ * @see device_stats
+ */
+typedef device_stats_t *device_stats_ref;
 
 /** Device state. */
Index: uspace/lib/c/include/net/modules.h
===================================================================
--- uspace/lib/c/include/net/modules.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/net/modules.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -69,5 +69,5 @@
  *
  * @param[in] need	The needed module service.
- * @return		The phone of the needed service.
+ * @returns		The phone of the needed service.
  */
 typedef int connect_module_t(services_t need);
Index: uspace/lib/c/include/net/packet.h
===================================================================
--- uspace/lib/c/include/net/packet.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/net/packet.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -46,5 +46,10 @@
  * @see packet
  */
-typedef struct packet packet_t;
+typedef struct packet * packet_t;
+
+/** Type definition of the packet pointer.
+ * @see packet
+ */
+typedef packet_t * packet_ref;
 
 /** Type definition of the packet dimension.
@@ -52,4 +57,9 @@
  */
 typedef struct packet_dimension	packet_dimension_t;
+
+/** Type definition of the packet dimension pointer.
+ * @see packet_dimension
+ */
+typedef packet_dimension_t * packet_dimension_ref;
 
 /** Packet dimension. */
@@ -69,18 +79,18 @@
 /*@{*/
 
-extern packet_t *pm_find(packet_id_t);
-extern int pm_add(packet_t *);
+extern packet_t pm_find(packet_id_t);
+extern int pm_add(packet_t);
 extern int pm_init(void);
 extern void pm_destroy(void);
 
-extern int pq_add(packet_t **, packet_t *, size_t, size_t);
-extern packet_t *pq_find(packet_t *, size_t);
-extern int pq_insert_after(packet_t *, packet_t *);
-extern packet_t *pq_detach(packet_t *);
-extern int pq_set_order(packet_t *, size_t, size_t);
-extern int pq_get_order(packet_t *, size_t *, size_t *);
-extern void pq_destroy(packet_t *, void (*)(packet_t *));
-extern packet_t *pq_next(packet_t *);
-extern packet_t *pq_previous(packet_t *);
+extern int pq_add(packet_t *, packet_t, size_t, size_t);
+extern packet_t pq_find(packet_t, size_t);
+extern int pq_insert_after(packet_t, packet_t);
+extern packet_t pq_detach(packet_t);
+extern int pq_set_order(packet_t, size_t, size_t);
+extern int pq_get_order(packet_t, size_t *, size_t *);
+extern void pq_destroy(packet_t, void (*)(packet_t));
+extern packet_t pq_next(packet_t);
+extern packet_t pq_previous(packet_t);
 
 /*@}*/
Index: uspace/lib/c/include/net/packet_header.h
===================================================================
--- uspace/lib/c/include/net/packet_header.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/c/include/net/packet_header.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -124,9 +124,9 @@
 /** Returns whether the packet is valid.
  * @param[in] packet	The packet to be checked.
- * @return		True if the packet is not NULL and the magic value is
+ * @returns		True if the packet is not NULL and the magic value is
  *			correct.
- * @return		False otherwise.
+ * @returns		False otherwise.
  */
-static inline int packet_is_valid(const packet_t *packet)
+static inline int packet_is_valid(const packet_t packet)
 {
 	return packet && (packet->magic_value == PACKET_MAGIC_VALUE);
